    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -------------------------------------
    028     * IntervalCategoryToolTipGenerator.java
    029     * -------------------------------------
    030     * (C) Copyright 2004, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: IntervalCategoryToolTipGenerator.java,v 1.3.2.1 2005/10/25 20:49:02 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 11-May-2004 : Version 1, split from IntervalCategoryItemLabelGenerator (DG);
    040     *
    041     */
    042
    043    package org.jfree.chart.labels;
    044
    045    import java.io.Serializable;
    046    import java.text.DateFormat;
    047    import java.text.NumberFormat;
    048
    049    import org.jfree.data.category.CategoryDataset;
    050    import org.jfree.data.category.IntervalCategoryDataset;
    051    import org.jfree.util.PublicCloneable;
    052
    053    /**
    054     * A tooltip generator for plots that use data from an
    055     * {@link IntervalCategoryDataset}.
    056     */
    057    public class IntervalCategoryToolTipGenerator
    058        extends StandardCategoryToolTipGenerator
    059        implements CategoryToolTipGenerator, PublicCloneable, Cloneable,
    060                   Serializable {
    061
    062        /** For serialization. */
    063        private static final long serialVersionUID = -3853824986520333437L;
    064
    065        /** The default format string. */
    066        public static final String DEFAULT_TOOL_TIP_FORMAT_STRING
    067            = "({0}, {1}) = {3} - {4}";
    068
    069        /**
    070         * Creates a new generator with a default number formatter.
    071         */
    072        public IntervalCategoryToolTipGenerator() {
    073            super(DEFAULT_TOOL_TIP_FORMAT_STRING, NumberFormat.getInstance());
    074        }
    075
    076        /**
    077         * Creates a new generator with the specified number formatter.
    078         *
    079         * @param labelFormat  the label format string (<code>null</code> not
    080         *                     permitted).
    081         * @param formatter  the number formatter (<code>null</code> not permitted).
    082         */
    083        public IntervalCategoryToolTipGenerator(String labelFormat,
    084                                                NumberFormat formatter) {
    085            super(labelFormat, formatter);
    086        }
    087
    088        /**
    089         * Creates a new generator with the specified date formatter.
    090         *
    091         * @param labelFormat  the label format string (<code>null</code> not
    092         *                     permitted).
    093         * @param formatter  the date formatter (<code>null</code> not permitted).
    094         */
    095        public IntervalCategoryToolTipGenerator(String labelFormat,
    096                                                DateFormat formatter) {
    097            super(labelFormat, formatter);
    098        }
    099
    100        /**
    101         * Creates the array of items that can be passed to the
    102         * <code>MessageFormat</code> class for creating labels.
    103         *
    104         * @param dataset  the dataset (<code>null</code> not permitted).
    105         * @param row  the row index (zero-based).
    106         * @param column  the column index (zero-based).
    107         *
    108         * @return The items (never <code>null</code>).
    109         */
    110        protected Object[] createItemArray(CategoryDataset dataset,
    111                                           int row, int column) {
    112            Object[] result = new Object[5];
    113            result[0] = dataset.getRowKey(row).toString();
    114            result[1] = dataset.getColumnKey(column).toString();
    115            Number value = dataset.getValue(row, column);
    116            if (getNumberFormat() != null) {
    117                result[2] = getNumberFormat().format(value);
    118            }
    119            else if (getDateFormat() != null) {
    120                result[2] = getDateFormat().format(value);
    121            }
    122
    123            if (dataset instanceof IntervalCategoryDataset) {
    124                IntervalCategoryDataset icd = (IntervalCategoryDataset) dataset;
    125                Number start = icd.getStartValue(row, column);
    126                Number end = icd.getEndValue(row, column);
    127                if (getNumberFormat() != null) {
    128                    result[3] = getNumberFormat().format(start);
    129                    result[4] = getNumberFormat().format(end);
    130                }
    131                else if (getDateFormat() != null) {
    132                    result[3] = getDateFormat().format(start);
    133                    result[4] = getDateFormat().format(end);
    134                }
    135            }
    136            return result;
    137        }
    138
    139    }